/*
 *	UDI MWC86 Version 2.3.3
 *	Copyright (c) 1982, 1983, 1984 by Mark Williams Company, Chicago.
 *	All rights reserved. May not be copied or disclosed without permission.
 */

/*
 * Some definitions for using
 * the Intel 8087 real mathematics
 * unit. Mostly flags and register
 * definitions.
 */
#define	RE_IE	0x01		/* An exception has occurred */
#define	RE_DE	0x02		/* Denormalized operand */
#define	RE_ZE	0x04		/* Zero divide */
#define	RE_OE	0x80		/* Real overflow */
#define	RE_UE	0x10		/* Real underflow */
#define	RE_PE	0x20		/* Precision */
#define	RE_IR	0x80		/* Interrupt request */

#define	RM_IM	0x0001		/* Invalid operation */
#define	RM_DM	0x0002		/* Denormalized operand */
#define	RM_ZM	0x0004		/* Zero divide */
#define	RM_OM	0x0008		/* Real overflow */
#define	RM_UM	0x0010		/* Real underflow */
#define	RM_PM	0x0020		/* Precision */
#define	RM_IEM	0x0080		/* Interrupt enable */
#define	RM_24	0x0000		/* 24 bit precision */
#define	RM_64	0x0300		/* 64 bit precision */
#define	RM_EVEN	0x0000		/* Round even */
#define	RM_DOWN	0x0400		/* Round down */
#define	RM_UP	0x0800		/* Round up */
#define	RM_CHOP	0x0C00		/* Chop */
#define	RM_PINF	0x0000		/* Projective infinity */
#define	RM_AINF	0x1000		/* Affine infinity */

/*
 * Real save area.
 */
struct	rsa
{
	int	rs_control;	/* Control word */
	int	rs_status;	/* Status word */
	int	rs_tag;		/* Tag word */
	int	rs_ip[2];	/* Instruction pointer */
	int	rs_op[2];	/* Operand pointer */
	int	rs_stack[8][5];	/* Operand stack, 8 levels, 5 words/level */
};
