/*
 *	UDI MWC86 Version 2.3.3
 *	Copyright (c) 1982, 1983, 1984 by Mark Williams Company, Chicago.
 *	All rights reserved. May not be copied or disclosed without permission.
 */

/*
 * File:	stdio.h
 * Last edit:	14-OCT-1982 18:19:20.31
 *
 * This header file contains 
 * typedefs, structures and macros for the
 * standard I/O library running on
 * the Intel iAPX-86 under UDI.
 */
#define	NULL	((char *) 0)		/* Null pointer */
#define	EOF	(-1)			/* End of file */
#define	BUFSIZ	128			/* Size of a buffer */
#define	_NBUF	0			/* # of buffers in dq$open call */
#define	_NFILE	10			/* # of FILE structures */

/*
 * This is a FILE; there is a FILE for
 * every open stream. An external array of these
 * files is used by the I/O package. If the flags
 * are 0 the FILE is not in use.
 */
typedef struct	 FILE {
	unsigned int _flag;		/* Flags */
	unsigned int _count;		/* Count remaining */
	int	     _ugetc;		/* Ungot character */
	unsigned char *_ptr;		/* Pointer */
	unsigned char *_buf;		/* Buffer */
	unsigned int _conn;		/* Connection */
	unsigned int _resp;		/* Response mailbox token for RMX */
}	FILE;

extern	FILE	_file[_NFILE];		/* The file structures */
extern	int	_fcol;			/* Console column */

/* Flags */
#define	_FWR	0x01			/* Writing */
#define	_FWROK	0x02			/* Writing is ok */
#define	_FRDOK	0x04			/* Reading is ok */
#define	_FBIN	0x08			/* 8 bits */
#define	_FUBUF	0x10			/* Buffer from setbuf */
#define	_FERR	0x20			/* Error */
#define	_FEOF	0x40			/* End of file */
#define	_FRMXTH	0x80			/* File is RMX terminal handler */
#define	_FCI	0x200			/* File is :ci: */
#define	_FCO	0x400			/* File is :co: */
#define	_FSTR	0x800			/* String stream */

char	*gets();
char	*fgets();
FILE	*fopen();
FILE	*freopen();
int	fflush();
int	fclose();
long	ftell();
void	setbuf();
char	*malloc();
char	*realloc();
char	*calloc();

#define	stdin		(&_file[0])
#define	stdout		(&_file[1])
#define	stderr		(&_file[2])
#define	getchar()	fgetc(stdin)
#define	getc(fp)	fgetc((fp))
#define	putchar(c)	fputc((c), stdout)
#define	putc(c, fp)	fputc((c), (fp))
#define	feof(fp)	((fp)->_flag&(_FEOF|_FERR))
#define	ferror(fp)	((fp)->_flag&_FERR)
#define	clearerr(fp)	((fp)->_flag &= ~(_FERR|_FEOF))
#define	fileno(fp)	((fp)->_conn)
#define	wdleng()	(16)
#define	_exit(s)	dq$exit((s))

#undef	COHERENT
#define	UDI	1
