/*
 *	UDI MWC86 Version 2.3.3
 *	Copyright (c) 1982, 1983, 1984 by Mark Williams Company, Chicago.
 *	All rights reserved. May not be copied or disclosed without permission.
 */

/*
 * This header file contains
 * typedefs, structures, macros and symbolic
 * constants used to interface with the
 * Intel UDI.
 * Error codes.
 * Returned by the system interface.
 */
#define	E$OK		0x0000		/* All ok */
#define	E$CONTEXT	0x0101		/* Call in illegal context */
#define	E$CROSSFS	0x0102		/* Cross volume */
#define	E$EXIST		0x0103		/* Something did not exist */
#define	E$FACCESS	0x0026		/* Access error */
#define	E$FEXIST	0x0020		/* File exists, and shouldn't */
#define	E$FNEXIST	0x0021		/* The file does not exist */
#define	E$MEM		0x0002		/* Not enough memory */
#define	E$NOPEN		0x0104		/* Connection not opened */
#define	E$OPEN		0x0105		/* Connection opened */
#define	E$OREAD		0x0106		/* Write to a read channel */
#define	E$OWRITE	0x0107		/* Read to a write channel */
#define	E$PARAM		0x0108		/* Illegal parameter */
#define	E$PTR		0x0109		/* Illegal pointer */
#define	E$SHARE		0x0028		/* Illegal operation on shared thing */
#define	E$SIX		0x010A		/* Six files open */
#define	E$SPACE		0x0029		/* The directory is full */
#define	E$STRING$BUF	0x0081		/* String too long */
#define	E$SUPPORT	0x010B		/* Function not supported */
#define	E$SYNTAX	0x010C		/* Path name syntax */
#define	E$UNSAT		0x010E		/* Unsatisfied externals in overlay */
#define	E$ADDRESS	0x010F		/* Overlay attempted over system */
#define	E$BAD$FILE	0x0110		/* Not an object file */
#define	E$ZERO$DIVIDE	0x8000		/* Divide by 0 */
#define	E$OVERFLOW	0x8001		/* INTO */
#define	E$8087		0x8007		/* An 8087 error */

/*
 * This structure describes the format
 * of the date and time as returned by the
 * get time system service.
 */
struct	gt
{
	char	gt_date[8];		/* The date */
	char	gt_time[8];		/* The time */
};

/*
 * This structure describes the connection
 * status as returned by the get connection status
 * system service.
 */
struct	gs
{
	char	gs_open;		/* Open flag */
	char	gs_access;		/* Access mode */
	char	gs_seek;		/* Seek code */
	long	gs_offset;		/* Seek offset in file */
};

/*
 * This structure describes file information
 * as returned by the dq$file$info system service.
 */
struct file$info {
	char	fi_owner[15];
	long	fi_length$of$file;
	char	fi_type;
	char	fi_owner$access;
	char	fi_world$access;
	long	fi_create$time;
	long	fi_last$mod$time;
	char	fi_reserved[20];
};

/*
 * Flags, codes and other stuff used by
 * the system. All have a name starting in DQ to
 * group them with the system.
 */
#define	DQ$DELETE	0x01		/* Delete */
#define	DQ$READ		0x02		/* Read */
#define	DQ$WRITE	0x04		/* Write */
#define	DQ$UPDATE	0x80		/* Update */

#define	DQ$SFOK		0x01		/* Seek forward ok */
#define	DQ$SBOK		0x02		/* Seek backward ok */

#define	DQ$MREAD	1		/* Read only */
#define	DQ$MWRITE	2		/* Write only */
#define	DQ$MUPDATE	3		/* Read and write */

#define	DQ$BACK		1		/* Back by offset */
#define	DQ$SET		2		/* Set to offset */
#define	DQ$FORWARD	3		/* Forward by offset */
#define	DQ$ENDBACK	4		/* Back by offset from end */

#define	DQ$NO		1		/* Not line edited */
#define	DQ$YES		2		/* Line edited */

/*
 * Status codes used by the
 * DQ$EXIT call. Thrown down the rathole
 * on the series III.
 */
#define	DQ$EXIT$OK	0		/* All ok */
#define	DQ$EXIT$WARN	1		/* Warnings */
#define	DQ$EXIT$ERROR	2		/* Errors */
#define	DQ$EXIT$FATAL	3		/* Fatal errors */
#define	DQ$EXIT$ABORT	4		/* Aborted */

/*
 * Some types.
 * These make it possible to say exactly
 * what you say in PL/M in C.
 * (Well, almost ...)
 */
typedef	unsigned char	boolean;	/* True or false */
typedef	unsigned char	byte;		/* As in PL/M */
typedef	unsigned	connection;	/* Stream connection */
typedef	long		dword;		/* Double word */
typedef	char		*pointer;	/* Not very useful */
typedef	unsigned	token;		/* System token */
typedef	unsigned	word;		/* As in PL/M */
